package com.danitheskunk.skunkworks;

abstract class BaseWindow implements IWindow {
	protected final Engine engine;

	BaseWindow(Engine engine) {
		this.engine = engine;
	}

	public IFont loadFontTileset(String path) {
		var img = engine.loadImage(path);
		var charSize = Vec2i.div(img.getSize(), 16);
		var tex = loadTextureArray(img, charSize);
		assert tex.size() == 256;
		return new FontTileset(tex);
	}
}
