package com.danitheskunk.skunkworks;

public final class Color {
	private final int r, g, b, a;
	public final static Color WHITE = new Color(255, 255, 255);

	public Color(int r, int g, int b) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = 0xff;
	}

	public Color(int r, int g, int b, int a) {
		this.r = r;
		this.g = g;
		this.b = b;
		this.a = a;
	}

	public int getR() {
		return r;
	}

	public int getG() {
		return g;
	}

	public int getB() {
		return b;
	}

	public int getA() {
		return a;
	}

	@Override public String toString() {
		return String.format("#%02X%02X%02X%02X", r, g, b, a);
	}
}
