package com.danitheskunk.skunkworks;

import org.lwjgl.BufferUtils;

import java.io.FileInputStream;
import java.io.IOException;
import java.nio.ByteBuffer;

import static com.danitheskunk.skunkworks.GraphicsBackend.*;

public class Engine {
	private final GraphicsBackend graphicsBackend;

	//Constructors
	public Engine() {
		this(OPENGL);
	}

	public Engine(GraphicsBackend graphicsBackend) {
		this.graphicsBackend = graphicsBackend;
	}

	//Methods
	public Image loadImage(String path) {
		ByteBuffer buf;
		byte[] bytes;
		try(FileInputStream fis = new FileInputStream(path)) {
			bytes = fis.readAllBytes();
		} catch(IOException e) {
			throw new RuntimeException(e);
		}
		buf = BufferUtils.createByteBuffer(bytes.length);
		buf.put(bytes);
		buf.flip();
		return new Image(buf);
	}

	public IWindow openWindow(Vec2i size, String title) {
		return switch(graphicsBackend) {
			case OPENGL -> new GLWindow(size, title, this);
		};
	}
}
