package com.danitheskunk.skunkworks;

import java.util.List;

class FontTileset implements IFont {
	private List<ITexture> textures;
	private Vec2i charSize;

	FontTileset(List<ITexture> textures) {
		this.textures = textures;
		this.charSize = textures.get(0).getSize();
	}

	@Override
	public int getCharWidth(int ch) {
		return charSize.getX();
	}

	@Override
	public int getLineHeight(int ch) {
		return charSize.getY();
	}

	@Override
	public ITexture getTexture(int ch) {
		if(ch >= 256 || ch < 0) {
			ch = 0;
		}
		return textures.get(ch);
	}
}
