package com.danitheskunk.skunkworks;

@SuppressWarnings("SpellCheckingInspection")
public final class Vec2i {
	private final int x, y;

	public final static Vec2i ZERO = new Vec2i(0, 0);

	//constructors

	public Vec2i(int x, int y) {
		this.x = x;
		this.y = y;
	}

	//getters and setters

	public int getX() {
		return x;
	}

	public int getY() {
		return y;
	}

	//static functions

	public static Vec2i add(Vec2i a, Vec2i b) {
		return new Vec2i(a.x + b.x, a.y + b.y);
	}

	public static Vec2i add(Vec2i a, Vec2i b, Vec2i c) {
		return new Vec2i(a.x + b.x + c.x, a.y + b.y + c.y);
	}

	public static Vec2i add(Vec2i a, Vec2i b, Vec2i c, Vec2i d) {
		return new Vec2i(a.x + b.x + c.x + d.x, a.y + b.y + c.y + d.y);
	}

	public static Vec2i sub(Vec2i a, Vec2i b) {
		return new Vec2i(a.x - b.x, a.y - b.y);
	}

	public static Vec2i mul(Vec2i a, int b) {
		return new Vec2i(a.x * b, a.y * b);
	}
	public static Vec2i mul(Vec2i a, Vec2i b) {
		return new Vec2i(a.x * b.x, a.y * b.y);
	}

	public static Vec2i div(Vec2i a, int b) {
		return new Vec2i(a.x / b, a.y / b);
	}
	public static Vec2i div(Vec2i a, Vec2i b) {
		return new Vec2i(a.x / b.x, a.y / b.y);
	}
	public static Vec2f divf(Vec2i a, double b) {
		return new Vec2f(a.x / b, a.y / b);
	}
	public static Vec2f divf(Vec2i a, Vec2f b) {
		return new Vec2f(a.x / b.getX(), a.y / b.getY());
	}
	public static Vec2f divf(Vec2i a, int b) {
		return new Vec2f(a.x / (double)b, a.y / (double)b);
	}
	public static Vec2f divf(Vec2i a, Vec2i b) {
		return new Vec2f(a.x / (double)b.x, a.y / (double)b.y);
	}
}
